/***************************************************************************
 *   Copyright (C) 2004 by ian reinhart geiser                             *
 *   geiseri@sourcextreme.com                                              *
 *                                                                         *
 *   This application is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2 of the License, or (at your option) any later version.      *
 *                                                                         *
 *   This application is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this application; if not, write to:                    *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <mainwindowbase.h>

class MainWindow : public MainWindowBase
{
Q_OBJECT
public:
	MainWindow ( QWidget * parent = 0, const char * name = 0, WFlags f = WType_TopLevel );
	virtual ~MainWindow();
	void openFile( const QString &file );

protected:
	bool eventFilter( QObject *obj, QEvent *ev );

public slots:
    virtual void fileOpen();
    virtual void fileExit();
    virtual void helpAbout();
    virtual void fileScreenCapture();
    virtual void slotHelpAboutQt();
    virtual void slotNewStyle( const QString & style );
    virtual void editCopy();
    virtual void slotClose();
    virtual void filePrint();

private:
	void updateChildren(const QString &style);
	void updateActions();
	QWidget *m_mainWidget;
	QString m_currFile;
};
#endif
