; Define your application name
!define APPNAME "QUIViewer"
!define APPNAMEANDVERSION "QUIViewer 1.2.1"

; Main Install settings
Name "${APPNAMEANDVERSION}"
InstallDir "$PROGRAMFILES\QUIViewer"
InstallDirRegKey HKLM "Software\${APPNAME}" ""
OutFile "Setup.exe"
CRCCheck on
XPStyle on
Icon quiviewer.ico

; Modern interface settings
!include "MUI.nsh"

!define MUI_ABORTWARNING
!define MUI_HEADERIMAGE
!define MUI_FINISHPAGE_RUN "$INSTDIR\quiviewer.exe"

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "lgpl.txt"
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

; Set languages (first is default language)
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_RESERVEFILE_LANGDLL

Section "QUIViewer" Section1

	; Set Section properties
	SetOverwrite on

	; Set Section Files and Shortcuts
	SetOutPath "$INSTDIR\"
	File "quiviewer.exe"
	File "$%QTDIR%\lib\qt-*.dll"
	;VC.Net libs
	File "C:\windows\system32\msvcp70.dll"
	File "C:\windows\system32\msvcr70.dll"
	
	
	CreateDirectory "$SMPROGRAMS\QUIViewer"
	CreateShortCut "$SMPROGRAMS\QUIViewer\QUIViewer.lnk" "$INSTDIR\quiviewer.exe"
	CreateShortCut "$SMPROGRAMS\QUIViewer\Uninstall.lnk" "$INSTDIR\uninstall.exe"

	SetOutPath "$INSTDIR\examples"
	File "examples\*.ui"
	
	CreateShortCut "$SMPROGRAMS\QUIViewer\examples.lnk" "$INSTDIR\Examples"
	
SectionEnd

Section "QUIViewer Source" Section2

	; Set Section properties
	SetOverwrite on

	; Set Section Files and Shortcuts
	SetOutPath "$INSTDIR\Source\"
	File "quiviewer.zip"
	
	CreateShortCut "$SMPROGRAMS\QUIViewer\source.lnk" "$INSTDIR\Source"
SectionEnd

Section "Send To shortcut" Section3
	CreateShortCut "$SENDTO\QUIViewer.lnk" "$INSTDIR\quiviewer.exe"
SectionEnd

Section "Desktop Icon" Section4
	CreateShortCut "$DESKTOP\QUIViewer.lnk" "$INSTDIR\quiviewer.exe"
SectionEnd

Section -FinishSection

	WriteRegStr HKLM "Software\${APPNAME}" "" "$INSTDIR"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayName" "${APPNAME}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "UninstallString" "$INSTDIR\uninstall.exe"
	WriteUninstaller "$INSTDIR\uninstall.exe"

SectionEnd

; Modern install component descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${Section1} "The QUIViewer binary."
	!insertmacro MUI_DESCRIPTION_TEXT ${Section2} "The QUIViewer source tree."
	!insertmacro MUI_DESCRIPTION_TEXT ${Section3} "Add QUIViewer to 'Send To' menu."
	!insertmacro MUI_DESCRIPTION_TEXT ${Section4} "Create a shortcut to QUIViewer on the desktop."
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;Uninstall section
Section Uninstall

	;Remove from registry...
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}"
	DeleteRegKey HKLM "SOFTWARE\${APPNAME}"

	; Delete self
	Delete "$INSTDIR\uninstall.exe"

	; Delete Shortcuts
	Delete "$DESKTOP\QUIViewer.lnk"
	Delete "$SMPROGRAMS\QUIViewer\QUIViewer.lnk"
	Delete "$SMPROGRAMS\QUIViewer\examples.lnk"
	Delete "$SMPROGRAMS\QUIViewer\source.lnk"
	Delete "$SMPROGRAMS\QUIViewer\Uninstall.lnk"
	Delete "$SENDTO\QUIViewer.lnk" 

	; Clean up QUIViewer
	Delete "$INSTDIR\quiviewer.exe"
	Delete "$INSTDIR\qt-mt*.dll"
	Delete "$INSTDIR\msvcp70.dll"
	Delete "$INSTDIR\msvcr70.dll"
	
	; Delete examples
	Delete "$INSTDIR\examples\*.ui"

; Clean up QUIViewer Source
	Delete "$INSTDIR\Source\*.*"
        Delete "$INSTDIR\Source\moc\*.*"
	Delete "$INSTDIR\Source\ui\*.*"
	Delete "$INSTDIR\Source\obj\*.*"
	
	; Remove remaining directories
	RMDir "$SMPROGRAMS\QUIViewer"
	RMDir "$INSTDIR\examples"
	RMDir /r "$INSTDIR\Source"
	RMDir "$INSTDIR\"
	

SectionEnd

BrandingText "2004 SourceXtreme, Inc."

; eof
